#include <stddef.h>
#include <stdlib.h>
#include "intlist.h"

#define T Intlist_T
struct T {
  int first;
  T rest;
};


T
Intlist_push (int i, T list) {
  T new = (T) malloc(sizeof(*new));

  new->first = i;
  new->rest = list;
  return new;
}
  

void
Intlist_free (T *intlist) {
  T prev;

  while ((prev = *intlist)) {
    *intlist = (*intlist)->rest;
    free(prev);
  }
}

T
Intlist_pop (T list, int *index) {
  T head;

  if (list) {
    head = list->rest;
    *index = list->first;
    free(list);
    return head;
  } else {
    return list;
  }
}

